dofile( "misc.lua" );
--global definitions
vol_max = 20;
scroll_text = "%artist%  -  %title%  '('%_length%')'   ***   ";
text_field_opt1 = " %_time_elapsed%";
text_field_opt2 = "-%_time_remaining%";
shuffle_off = "Default";
volume_change = 0.5;
--blend_in = 0.1;
blend_out = 1.5;
fade_alpha = 4;
--alpha_sleep = 
hover_alpha = 120;

if (foobar.get_volume() < -2000) then
	vol_max = -foobar.get_volume();
end

function option(key, defvalue, show, list)
	local value = config.load(defvalue, key);
	config.save(value, key, show, list);
	return value;
end

--[[
Options (part 1)
--]]
if option("Show remaining time", false, false) then
	text_field_opt = text_field_opt2;
else
	text_field_opt = text_field_opt1;
end

button_class = new_base_class(true);
function button_class:create(func, base, down, string, global, no_blend_out)
	self.base = base;
	self.func = func;
	self.down = down;
	self.string = string;
	self.global = global;
	self.no_blend_out = no_blend_out;
end
function button_class:draw()
	self.window:draw_part(self.part, self.base);
end
function button_class:message(type)
	if (type == 0) then
		button_class[self.global] = true;
		self.window:add_active(self.ref);
		self.window:draw_part(self.part, self.down);
		set_info(self.string);
		return true;
	elseif (type == 1) then
		button_class[self.global] = false;
		self.window:remove_active(self.ref);
		if (self.part:mouse_inside()) then
			self.func();
			if (self.no_blend_out) then
				self.window:redraw_part(self.part);
			else
				self.window:animate(self.part, self.base, self.down, fade_alpha, 255, 0, 100);
			end
		end
		return true;
	elseif (type == 9) then
		if (button_class[self.global]) then
			--self.window:add_active(self.ref);
			self.window:draw_part(self.part, self.down);
			set_info(self.string);
		end	
		return true;
	elseif (type == 10) then
		if (button_class[self.global]) then
			self.window:animate(self.part, self.base, self.down, blend_out, 255, 0, 100);
			set_info(scroll_text);
		end		
		return true;
	end
end

text_field2_font = option("Large font", font.new("Arial", 16, 11, 400))
text_field_font = option("Small font", font.new("Arial", 8, 5, 400));
pl_focus = option("Active item frame color", color.new(255, 255, 255));
pl_small_text = option("Playlist format (window-shade mode)", "[$if2(%artist%,%album artist%) - ]$if2(%title%,%_filename%)[ %_length%]");
shuffle_on = option("Playback order for shuffle button", "Shuffle (tracks)", true, foobar.get_orders());
repeat_on = option("Playback order for repeat button", "Repeat One", true, foobar.get_orders());
uie_vis = option("Visualization", "Spectrum analyser", true, { "Simple Spectrum", "VU meter" })
show_time_in_pl = option("show time in playlist", false, false);
sync_pl_window_width = option("sync playlist window width", true, true);

--config.enable( false );


local bm_titlebar = bitmap.new( "waskin\\titlebar.bmp" );
bm_win1 = bitmap.new();
bm_titlebar:copy_to( bm_win1, 0, 0, 27, 42, 275, 14 );
bm_titlebar:copy_to( bm_win1, 0, 14, 27, 30, 275, 13 );
bm_titlebar:copy_to( bm_win1, 275, 0, 0, 9, 27, 9 );
bm_titlebar:copy_to( bm_win1, 275, 9, 0, 27, 27, 16 );
bm_titlebar:copy_to( bm_win1, 6, 3, 0, 0, 9, 9 );

bm_win2 = bitmap.new( "waskin\\main.bmp" );
local bm_buttons = bitmap.new( "waskin\\cbuttons.bmp" );
bm_titlebar:copy_to( bm_win2, 0, 0, 27, 15, 275, 14 );
bm_titlebar:copy_to( bm_win2, 0, 116, 27, 0, 275, 14 );
bm_buttons:copy_to( bm_win2, 16, 88, 0, 0, 114, 18 );
bm_buttons:copy_to( bm_win2, 0, 130, 0, 18, 114, 18 );
bm_titlebar:copy_to( bm_win2, 114, 130, 0, 9, 27, 18 );
bm_buttons:copy_to( bm_win2, 136, 89, 114, 0, 22, 16 );
bm_buttons:copy_to( bm_win2, 141, 130, 114, 16, 22, 16 );
local bm_shufref = bitmap.new( "waskin\\shufrep.bmp" );
bm_shufref:copy_to( bm_win2, 0, 148, 0, 15 );
bm_shufref:copy_to( bm_win2, 164, 89, 28, 0, 46, 15 );
bm_shufref:copy_to( bm_win2, 210, 89, 0, 0, 28, 15 );
bm_shufref:copy_to( bm_win2, 219, 58, 0, 61, 23, 12 );
bm_shufref:copy_to( bm_win2, 242, 58, 23, 61, 23, 12 );
local bm_posbar = bitmap.new( "waskin\\posbar.bmp" );
bm_posbar:copy_to( bm_win2, 0, 233, 248, 0, 59, 10 );
bm_posbar:copy_to( bm_win2, 16, 72, 0, 0, 249, 10 );
local bm_volume = bitmap.new( "waskin\\volume.bmp" );
vol_width = math.min( bm_volume:get_size().x, 68 );
bm_volume:copy_to( bm_win2, 0, 258, 0, 422, 29, 11 );
bm_volume:copy_to( bm_win2, 275, 0, 0, 0, vol_width, 418 );

bm_win3 = bitmap.new( "waskin\\pledit.bmp" );

bm_win4 = bitmap.new();
bm_win3:copy_to( bm_win4, 0, 0, 72, 42, 88, 29);
bm_win3:copy_to( bm_win4, 78, 10, 52, 42, 9, 9);

local bm_text = bitmap.new( "waskin\\text.bmp" );

pl_font = font.new("Verdana", 11, 0, 0);
pl_text_color = bm_text:get_pixel(0, 4);
pl_bg_color = bm_text:get_pixel(0, 0);
pl_bg_color_sel = color.new(10, 36, 106);
get_winamp_pl_info( "waskin\\pledit.txt", pl_text_color, pl_bg_color, pl_bg_color_sel, pl_font );

--[[
Options (part 2)
--]]
text_field_color = option("Scrolling text color", bm_text:get_pixel(0, 4));
pl_font = option("Playlist font", pl_font);
pl_text_color = option("Playlist text color", pl_text_color);
pl_bg_color = option("Playlist background color", pl_bg_color);
pl_bg_color_sel = option("Playlist selection background color", pl_bg_color_sel);

--config.enable( true );
function set_def_string()
	set_info(scroll_text);
end
function window:setup_button(bm, part, image, func, string, no_blend_out)
	local s_inf = nil;
	local s_out = nil;
	if (string ~= nil) then
		s_inf = function()
			set_info(string);
		end
		s_out = set_def_string;
	end
	local b = button.new(part, image.new(bm, part), 0, func, s_inf, s_inf, s_out);
	b:add_state(nil, image, image, nil, hover_alpha);
	self:add( b );
	return b;
end
--[[function window:setup_button(part, image, func, string)
	local LDown_ = function()
		button_status = part;
		self:draw_part(part, image);
		--self:animate(part, part, image, blend_in, 0, 255, 0);
		set_info(string);
	end
	local hoverEnter_ = function()
		if (button_status ~= nil) then
			self:draw_part(part, image);
			--self:animate(part, part, image, blend_in, 0, 255, 0);
			button_status = part;
			set_info(string);
		end
	end
	local hoverLeave_ = function()
		if (button_status == part) then
			--self:redraw_part(part);
			self:animate(part, part, image, blend_out, 255, 0, 100);
			set_info(scroll_text);
		end
	end
	local LUp_ = function()
		if (button_status == part) then
			button_status = nil;
			if (func()) then
				self:redraw_part(part);
			else
				self:animate(part, part, image, fade_alpha, 255, 0, 100);
			end
		end
	end
	
	self:add_part_callback( "LDown", part, LDown_ );
	self:add_part_callback( "hoverEnter", part, hoverEnter_ );
	self:add_part_callback( "hoverLeave", part, hoverLeave_ );
	self:add_part_callback( "LUp", part, LUp_ );
end]]

function window:setActivate(func1, func2)
	self:set_callback( "OnActivate", func1 );
	self:set_callback( "OnDeactivate", func2 );
end

--[[function window:create_resizable(edge, clip, width, height)
	local r = rect.new(0, 0, edge.left, clip.top);
	self:add_paint_part( r, r );
	self:add_paint_part( rect.new(edge.left, 0, edge.right - 1, clip.top), rect.new(edge.left, 0, edge.right - width, clip.top) );
	--self:add_paint_part( rect.new(
end]]

scroll_timer = timer.new( function() text_scroll:scroll_left(6); end );
scroll_start_timer = timer.new( function()
	scroll_start_timer:stop();
	text_scroll:update( scroll_text, true );
	if (foobar.is_playing() > 0) then
		scroll_timer:start( 200 );
		text_scroll:set_activated( true );
	end
end );
scroll_start_timer2 = timer.new( function()
	scroll_start_timer2:stop();
	text_scroll:update( scroll_text, true );
	--text_scroll:set_activated( true );
	scroll_start_timer:start( 2000 );
end );
function set_info(string)
	scroll_start_timer:stop();
	scroll_start_timer2:stop();
	scroll_timer:stop();
	if (win2:is_visible() and string) then
		local plain = 2;
		if (string == scroll_text) then plain = 0; end
		text_scroll:update( string, plain );
		text_scroll:reset_pos();
		if (string == scroll_text) then
			scroll_start_timer:start( 2000 );
		else
			scroll_start_timer2:start( 2000 );
		end
		if (foobar.is_playing() == 0) then
			text_scroll:set_activated(false);
		end
	end
end

i1_main = image.new(bm_win1, rect.new_size(0, 0, 275, 14));
i1_active = image.new(bm_win1, rect.new_size(0, 13, 275, 14));
i1_config = image.new(bm_win1, rect.new1(275, 0, 283, 8));
i1_minimize = image.new(bm_win1, rect.new1(284, 0, 292, 8));
i1_switch = image.new(bm_win1, rect.new1(284, 9, 292, 17));
i1_close = image.new(bm_win1, rect.new1(293, 0, 301, 8));
i1_slider = image.new(bm_win1, rect.new_size(292, 18, 3, 7));

p1_config = rect.new1(6, 3, 14, 11);
p1_prev = rect.new1(168, 3, 175, 11);
p1_play = rect.new1(177, 3, 184, 11);
p1_pause = rect.new1(187, 3, 194, 11);
p1_stop = rect.new1(197, 3, 203, 11);
p1_next = rect.new1(205, 3, 212, 11);
p1_open = rect.new1(215, 3, 223, 11);
p1_minimize = rect.new1(244, 3, 252, 11);
p1_switch = rect.new1(254, 3, 262, 11);
p1_close = rect.new1(264, 3, 272, 11);
p1_text = rect.new1(126, 2, 158, 10);
p1_bar = rect.new_size(226, 4, 16, 7);
p1_main = rect.new_size(0, 0, 275, 14);
p_all = rect.new(-9999, -9999, 9999, 9999);

function w1_update()
	progBar1.pos = foobar.time_elapsed();
	text_time1:update();
end

function w1_newTrack()
	progBar1.max = foobar.title_playtime();
	w1_update();
	playlist_newTrack();
end

function switch12() 
	win1:switch_to(win2);
end 

text_time1 = textfield.new( p1_text, text_field_opt, 0, text_field_font, text_field_color, true );
--p1_bar
progBar1 = progbar.new( p1_bar, i1_slider, 0, 
	function() prog_temp = progBar1.pos; end, 
	function() foobar.seek(progBar1.pos); end
);
--text_time1:update();

win1 = window.new("ui", 275, 14, rect.new(0, 0, 275, 14) );
win1:add_paint_part(p1_main, i1_main);
win1:add( text_time1, progBar1 );
win1:add_part_callback("LDown", p1_prev, foobar.prev );
win1:add_part_callback("LDown", p1_play, foobar.play );
win1:add_part_callback("LDown", p1_pause, foobar.pause );
win1:add_part_callback("LDown", p1_stop, foobar.stop );
win1:add_part_callback("LDown", p1_next, foobar.next );

win1:add_part_callback("LDown", p1_text, function()
	if (text_time1:get_text() == text_field_opt1) then
		text_time1:set_text( text_field_opt2 );
		w3_time:set_text( text_field_opt2 );
	else
		text_time1:set_text( text_field_opt1 );
		w3_time:set_text( text_field_opt1 );
	end
	text_time1:update();
	w3_time:update();
end );

--exit seek on right-click
win1:add_part_callback( "RDown", p_all, function()
	if (progBar1.sliding == true) then
		progBar1.pos = prog_temp;
		foobar.seek( prog_temp );
		progBar1.sliding = false;
		text_time1:update();
	end
end );

--change main-image on activate/deactivate
win1:setActivate( function()
	--win1:set_mainImage( i1_active );
	win1:set_picture(p1_main, i1_active, true);
end, function()
	win1:reset_picture(p1_main, true);
	--win1:set_mainImage( i1_main );
end );

win1:set_callback( "OnWheelDown", function()
	foobar.set_volume( foobar.get_volume() - volume_change );
end );
win1:set_callback( "OnWheelUp", function()
	foobar.set_volume( foobar.get_volume() + volume_change );
end );


win1:setup_button( bm_win1, p1_config, i1_config, function() foobar.show_main_menu(); end );
win1:setup_button( bm_win1, p1_minimize, i1_minimize, function() foobar.run_menu_command("Hide"); end );
win1:setup_button( bm_win1, p1_close, i1_close, foobar.quit );
win1:setup_button( bm_win1, p1_switch, i1_switch, switch12 );
win1:add_part_callback( "LDbl", p1_main, switch12 );
win1:add_part_callback( "LUp", p_all, function() button_status = nil; end );

win1:set_callback( "OnShow", function()
	set_global_callback( "OnTime", w1_update );
	set_global_callback( "OnSeek", w1_update );
	set_global_callback( "OnNewTrack", w1_newTrack );
	text_time1:set_text( text_time2:get_text() );
	set_info( scroll_text );
	w1_newTrack();
end );
win1:set_callback( "OnClose", foobar.quit );
win1:set_add_file_option( 2 );

--######### WINDOW 1 - BIG ###########

i2_main = image.new(bm_win2, rect.new_size(0, 0, 275, 116));
i2_activated = image.new(bm_win2, rect.new_size(0, 116, 275, 14));
i2_prev = image.new(bm_win2, rect.new_size(0, 130, 22, 18));
i2_play = image.new(bm_win2, rect.new_size(22, 130, 23, 18));
i2_pause = image.new(bm_win2, rect.new_size(45, 130, 23, 18));
i2_stop = image.new(bm_win2, rect.new_size(68, 130, 23, 18));
i2_next = image.new(bm_win2, rect.new_size(91, 130, 23, 18));
i2_open = image.new(bm_win2, rect.new_size(141, 130, 22, 16));
i2_config = image.new(bm_win2, rect.new_size(114, 130, 9, 9));
i2_minimize = image.new(bm_win2, rect.new_size(123, 130, 9, 9));
i2_switch = image.new(bm_win2, rect.new_size(123, 139, 9, 9));
i2_close = image.new(bm_win2, rect.new_size(132, 130, 9, 9));
i2_repeat_down = image.new(bm_win2, rect.new_size(0, 148, 28, 15));
i2_repeat_active = image.new(bm_win2, rect.new_size(0, 163, 28, 15));
i2_repeat_active_down = image.new(bm_win2, rect.new_size(0, 178, 28, 15));
i2_shuffle_down = image.new(bm_win2, rect.new_size(28, 148, 46, 15));
i2_shuffle_active = image.new(bm_win2, rect.new_size(28, 163, 46, 15));
i2_shuffle_active_down = image.new(bm_win2, rect.new_size(28, 178, 46, 15));
i2_playlist_active = image.new(bm_win2, rect.new_size(23, 206, 23, 12));
i2_playlist_down = image.new(bm_win2, rect.new_size(69, 194, 23, 12));
i2_playlist_active_down = image.new(bm_win2, rect.new_size(69, 206, 23, 12));
i2_slider = image.new(bm_win2, rect.new_size(0, 233, 29, 10));
i2_seek_click = image.new(bm_win2, rect.new_size(30, 233, 29, 10));
if (bm_volume:get_size().y > 422) then
	i2_vol = image.new(bm_win2, rect.new_size(0, 258, 14, 11));
	i2_vol_click = image.new(bm_win2, rect.new_size(15, 258, 14, 11));
else
	i2_vol = image.new(bm_win2, rect.new_size(0, 0, 0, 0));
	i2_vol_click = i2_vol;
end
i2_vol_tmp = rect.new_size(275, 0, vol_width, 13);
--i2_tmp = rect.new_size(0, 270, 1, 1);

p2_main = rect.new_size(0, 0, 275, 116);
p2_titleBar = rect.new_size(0, 0, 275, 14);
p2_vis = rect.new_size(25, 43, 75, 15);
p2_prev = rect.new_size(16, 88, 22, 18);
p2_play = rect.new_size(38, 88, 23, 18);
p2_pause = rect.new_size(61, 88, 23, 18);
p2_stop = rect.new_size(84, 88, 23, 18);
p2_next = rect.new_size(107, 88, 23, 18);
p2_open = rect.new_size(136, 89, 22, 16);
p2_config = rect.new1(6, 3, 14, 11);
p2_minimize = rect.new1(244, 3, 252, 11);
p2_switch = rect.new1(254, 3, 262, 11);
p2_close = rect.new1(264, 3, 272, 11);
p2_vol = rect.new1(107, 58, 171, 68);
p2_vol2 = rect.new_size(107, 57, vol_width, 13);
p2_prog = rect.new1(16, 72, 264, 81);
p2_text = rect.new1(28, 24, 100, 39);
p2_shuffle = rect.new_size(164, 89, 46, 15);
p2_repeat = rect.new_size(210, 89, 28, 15);
p2_scroll = rect.new1(110, 25, 264, 32);
p2_kbps = rect.new1(109, 41, 126, 50);
p2_khz = rect.new1(154, 41, 166, 50);
p2_playlist = rect.new_size(242, 58, 23, 12);
p2_lib = rect.new_size(249, 89, 18, 18);

--local c2_pause = button_class.new(p2_pause, foobar.pause, p2_pause, i2_pause, "pause", 0);

text_time2 = textfield.new( p2_text, text_field_opt, 0, text_field2_font, text_field_color, true );
--text_time2:set_draw_mode( 100 );
text_kbps = textfield.new( p2_kbps, "$if2(%__bitrate_dynamic%,%__bitrate%)", 0, text_field_font, text_field_color );
text_khz = textfield.new( p2_khz, "$div(%__samplerate%, 1000)", 0, text_field_font, text_field_color );

text_scroll = text_scroll.new( p2_scroll, "asdf", 2, text_field_font, text_field_color, 
	function() scroll_timer:stop(); end,
	function() scroll_start_timer:start( 1000 ); end
);
--text_scroll:set_draw_mode( 100 );

vol_bar = progbar.new( p2_vol, i2_vol, vol_max, 
	function() vol_bar.slider = i2_vol_click; vol_bar:redraw(); end,
	function() foobar.set_volume(vol_bar.pos - vol_bar.max); end,
	function() vol_bar.slider = i2_vol; vol_bar:redraw(); end
);

seek_bar = progbar.new( p2_prog, i2_slider, 0, 
	function() seek_bar.slider = i2_seek_click; seek_bar:redraw(); prog_temp = seek_bar.pos;  end,
	function() foobar.seek(seek_bar.pos); end, 
	function() seek_bar.slider = i2_slider; seek_bar:redraw(); end
);
--seek_bar:set_draw_mode( -3 );
--seek_bar:set_draw_mode(100);
if (foobar.is_playing() == false) then 
	seek_bar.show = false;
	seek_bar.enabled = false;
end
--text_time2:update();
win2 = window.new("ui main", 275, 116, rect.new(0, 0, 275, 116));
win2:add_paint_part( p2_main, i2_main );
--[[c2_vis = ui_ext.new( p2_vis, uie_vis )
if c2_vis then
	win2:add( c2_vis )
	win2:add_part_callback("RDown", p2_vis, function() c2_vis:show_menu(window.get_mouse_pos()); end );
end]]
win2:add( text_time2, text_kbps, text_khz, text_scroll );
win2:add( vol_bar, seek_bar );
--win2:add( c2_pause );
--vol_bar:set_draw_mode( -3 );

win2:add_part_callback( "LDbl", p2_scroll, function()
	foobar.run_context_command( "Properties" );
end );
win2:add_part_callback( "RDown", p2_scroll, function()
	foobar.show_context_menu();
end );

win2:add_part_callback( "LDown", p2_lib, function()
	foobar.run_menu_command("Album List");
end );


--text-toggle
win2:add_part_callback( "LDown", p2_text, function()
	if (text_time2:get_text() == text_field_opt1) then
		text_time2:set_text( text_field_opt2 );
		w3_time:set_text(text_field_opt2);
	else
		text_time2:set_text( text_field_opt1 );
		w3_time:set_text(text_field_opt1);
	end
	text_time2:update();
	w3_time:update();
end );

--exit seek on right-click
win2:add_part_callback( "RDown", p_all, function()
	if (seek_bar.sliding == true) then
		seek_bar.slider = i2_slider;
		seek_bar.pos = prog_temp;
		foobar.seek( prog_temp );
		seek_bar.sliding = false;
		text_time2:update();
	end
end );

--update seek-bar & text
function w2_update()
	seek_bar.pos = foobar.time_elapsed();
	text_time2:update();
	if (win3:is_visible()) then
		w3_time:update();
	end
end

function w2_newTrack()
	w2_update();
	text_kbps:update();
	seek_bar.max = foobar.title_playtime();
	text_khz:update();
	set_info( scroll_text );
	text_scroll:set_activated(true);
	playlist_newTrack();
end

function w2_update_order(not_show)
	if (foobar.get_order() == shuffle_on) then
		w2_shuff.state = 1;
		w2_rep.state = 0;
	elseif (foobar.get_order() == repeat_on) then
		w2_rep.state = 1;
	else
		w2_rep.state = 0;
	end
	if (not_show ~= true) then
		set_info( string.format("order: %s",  foobar.get_order()) );
	end
end

--title-bar-image-switch on (de)activation
win2:setActivate( --TODO: gibts nemmer
	function() win2:set_picture( p2_titleBar, i2_activated, true ); end,
	function() win2:reset_picture( p2_titleBar, true, i2_tmp ); end 
);

function w2_dynamic()
	text_kbps:update();
end

function switch21() win2:switch_to(win1); end

--shuffle button
w2_shuff = win2:setup_button( bm_win2, p2_shuffle, i2_shuffle_down, function()
	w2_shuff:cycle_state();
	if (w2_rep.state == 0) then
		if (w2_shuff.state == 1) then foobar.set_order(shuffle_on);
		else foobar.set_order(shuffle_off); end
	end
end, string.format("toggle %s", shuffle_on) );
w2_shuff:add_state(i2_shuffle_active, i2_shuffle_active_down, i2_shuffle_active_down, nil, hover_alpha);

--repeat button
w2_rep = win2:setup_button( bm_win2, p2_repeat, i2_repeat_down, function()
	w2_rep:cycle_state();
	if (w2_rep.state == 1) then foobar.set_order(repeat_on);
	elseif (w2_shuff.state == 1) then foobar.set_order(shuffle_on);
	else foobar.set_order(shuffle_off); end
end, string.format("toggle %s", repeat_on) );
w2_rep:add_state(i2_repeat_active, i2_repeat_active_down, i2_repeat_active_down, nil, hover_alpha);

--playlist toggle
w2_pl = win2:setup_button( bm_win2, p2_playlist, i2_playlist_down, function()
	if (win3:is_visible()) then
		win3:close();
		set_info( "playlist disabled" );
	elseif (win4:is_visible()) then
		win4:close();
		set_info( "playlist disabled" );
	else
		cur_playlist:create();
		set_info( "playlist enabled" );
	end
end, "toggle playlist" ); 
w2_pl:add_state(i2_playlist_active, i2_playlist_active_down, i2_playlist_active_down, nil, hover_alpha);

win2:set_callback( "OnWheelDown", function()
	foobar.set_volume( foobar.get_volume() - volume_change );
end );
win2:set_callback( "OnWheelUp", function()
	foobar.set_volume( foobar.get_volume() + volume_change );
end );


win2:setup_button( bm_win2, p2_config, i2_config, function() foobar.show_main_menu(); end, "config" );
win2:setup_button( bm_win2, p2_minimize, i2_minimize, function() foobar.run_menu_command("Hide"); end, "minimize" );
win2:setup_button( bm_win2, p2_switch, i2_switch, switch21, "switch to window-shade-mode" );
win2:setup_button( bm_win2, p2_close, i2_close, foobar.quit, "quit foobar" );
win2:setup_button( bm_win2, p2_prev, i2_prev, foobar.prev, "previous track" );
win2:setup_button( bm_win2, p2_play, i2_play, foobar.play, "play" );
win2:setup_button( bm_win2, p2_pause, i2_pause, foobar.pause, "pause" );
win2:setup_button( bm_win2, p2_stop, i2_stop, foobar.stop, "stop" );
win2:setup_button( bm_win2, p2_next, i2_next, foobar.next, "next/random track" );
win2:setup_button( bm_win2, p2_open, i2_open, function() foobar.run_menu_command("Open..."); end, "open files" );
win2:add_part_callback( "LUp", p_all, function() button_status = nil; end );

win2:add_part_callback( "LDbl", p2_titleBar, switch21 );

win2:set_callback( "OnShow", function()
	set_global_callback( "OnTime", w2_update );
	set_global_callback( "OnSeek", w2_update );
	set_global_callback( "OnNewTrack", w2_newTrack );
	set_global_callback( "OnDynamic", w2_dynamic );
	text_time2:set_text( text_time1:get_text() );
	foobar.set_volume(foobar.get_volume());
	--vol_bar:set( "pos", vol_bar.max + foobar.get_volume() );
	w2_newTrack();
	w2_update_order( true );
	--[[if (foobar.get_order() == repeat_on) then
		win2:set_picture( p2_repeat, i2_repeat_active, true );
		repeat_button = i2_repeat_active_down;		
	else
		win2:reset_picture( p2_repeat, true, i2_tmp );
		repeat_button = i2_repeat_down;
		if (foobar.get_order() == shuffle_on) then
			win2:set_picture( p2_shuffle, i2_shuffle_active, true );
			shuffle_button = i2_shuffle_active_down;
		else
			win2:reset_picture( p2_shuffle, true, i2_tmp );
			shuffle_button = i2_shuffle_down;
		end
	end]]
end );
win2:set_callback( "OnHide", function()
	set_global_callback( "OnDynamic", nil );
end );
win2:set_callback( "OnClose", foobar.quit );
win2:set_add_file_option( 2 );

--############### WINDOW 3 - PLAYLIST BIG ###############

i3_tl_active = image.new(bm_win3, rect.new_size(0, 0, 25, 20));
i3_tm_active = image.new(bm_win3, rect.new_size(26, 0, 100, 20));
i3_ttt_active = image.new(bm_win3, rect.new_size(127, 0, 25, 20));
i3_tr_active = image.new(bm_win3, rect.new_size(153, 0, 25, 20));
i3_tl = image.new(bm_win3, rect.new_size(0, 21, 25, 20));
i3_tm = image.new(bm_win3, rect.new_size(26, 21, 100, 20));
i3_ttt = image.new(bm_win3, rect.new_size(127, 21, 25, 20));
i3_tr = image.new(bm_win3, rect.new_size(153, 21, 25, 20));
i3_ttl = image.new(bm_win3, rect.new_size(0, 42, 14, 29));
i3_ttr = image.new(bm_win3, rect.new_size(26, 42, 25, 29));
i3_bl = image.new(bm_win3, rect.new_size(0, 72, 125, 38));
i3_br = image.new(bm_win3, rect.new_size(126, 72, 150, 38));
i3_btt = image.new(bm_win3, rect.new_size(179, 0, 25, 38));

local i3_pl_slider = image.new(bm_win3, rect.new_size(52, 53, 8, 18));
i3_pl_slider_activated = image.new(bm_win3, rect.new_size(61, 53, 8, 18));
i3_close = image.new(bm_win3, rect.new_size(52, 42, 9, 9));
i3_switch = image.new(bm_win3, rect.new_size(62, 42, 9, 9));

p3_tl = rect.new_size(0, 0, 25, 20);
p3_ttlt = rect.new_size(25, 0, 25, 20);
p3_mt = rect.new_size(50, 0, 100, 20);
p3_ttrt = rect.new(150, 0, -25, 20);
p3_tr = rect.new(-25, 0, 0, 20);
p3_ttl = rect.new(0, 20, 14, -38);
p3_ttr = rect.new(-25, 20, 0, -38);
p3_bl = rect.new(0, -38, 125, 0);
p3_btt = rect.new(125, -38, -150, 0);
p3_br = rect.new(-150, -38, 0, 0);

p3_pl = rect.new(14, 20, -25, -38);
--p3_pl = rect.new(20, 20, -50, -38);
p3_pl_scroll = rect.new(-15, 17, -7, -34);
p3_size = rect.new(-18, -18, 0, 0);
p3_switch = rect.new(-20, 3, -11, 12);
p3_close = rect.new(-11, 3, -2, 12);
p3_bar = rect.new(0, 0, 0, 15);
p3_pl_switcher = rect.new(-170, -31, -49, -5);


--i3_main = rect.new1(0, 0, 299, 115);
--i3_switch = rect.new1(300, 27, 308, 35);
--i3_active = rect.new1(0, 116, 299, 127);
--i3_close = rect.new1(300, 18, 308, 26);
--i3_pl_slider = rect.new1(300, 0, 307, 17);
--
--p3_edge = rect.new1(123, 20, 153, 77);
--p3_switch = rect.new1(279, 3, 287, 11);
--p3_close = rect.new1(289, 3, 297, 11);
--p3_active = rect.new1(0, 0, 299, 11);
--p3_size = rect.new1(281, 97, 299, 115);
--p3_pl = rect.new1(11, 20, 280, 77);
--p3_pl_scroll = rect.new1(285, 19, 292, 78);
--p3_bar = rect.new1(0, 0, 278, 11);


w3_playlist = playlist.new( p3_pl, pl_font, pl_text_color, pl_bg_color, pl_bg_color_sel, pl_focus, function() 
	if (w3_scrollbar.sliding == false) then 
		w3_scrollbar.pos = w3_playlist:get_pos();
	end
end );
--w3_playlist:set_draw_mode( -1 );

w3_time = textfield.new( rect.new(-300, -90, -50, -35), text_field_opt, 0, text_field2_font, color.new(255, 0, 0 ) --[[text_field_color]], true );
w3_time:set_draw_mode( 50 );
if (show_time_in_pl==false) then
	w3_time:set_draw_mode( 0 );
end

w3_color = color_rect.new( rect.new(14, 20, -30, -38), color.new(0, 0, 0) );

function w3_check_scrollable()
	local scrollable = w3_playlist:scrollable();
	local shown_before = w3_scrollbar.show;
	if (scrollable) then
		w3_scrollbar.show = true;
		w3_scrollbar.enabled = true;
	else
		w3_scrollbar.show = false;
		w3_scrollbar.enabled = false;
	end
	if (scrollable ~= shown_before) then
		w3_scrollbar:redraw();
	end
end
w3_scrollbar = progbar.new( p3_pl_scroll, i3_pl_slider, 100, nil,
	function() w3_playlist:set_pos( w3_scrollbar.pos ); end,
	w3_check_scrollable
);

set_global_callback( "OnPlaylistCountChanged", w3_check_scrollable );

win3 = window.new("pl", 300, 116, rect.new(0, 0, 300, 116), 3);
win3:add( w3_playlist, w3_time );
win3:add_paint_part(p3_tl, i3_tl_active);
win3:add_paint_part(p3_ttlt, i3_ttt_active);
win3:add_paint_part(p3_mt, i3_tm_active);
win3:add_paint_part(p3_ttrt, i3_ttt_active);
win3:add_paint_part(p3_tr, i3_tr_active);
win3:add_paint_part(p3_ttl, i3_ttl, 1);
win3:add_paint_part(p3_ttr, i3_ttr, 1);
win3:add_paint_part(p3_bl, i3_bl);
win3:add_paint_part(p3_btt, i3_btt);
win3:add_paint_part(p3_br, i3_br);
win3:add( w3_scrollbar );
win3:add( p3_size, p3_bar );

--[[c3_pl_switcher = ui_ext.new( p3_pl_switcher, "playlist switcher" )
win3:add( c3_pl_switcher, p3_pl_switcher )
win3:add_part_callback( "RDown", p3_pl_switcher, function()
	c3_pl_switcher:show_menu(window.get_mouse_pos())
end )]]

win3:add_part_callback( "LDown", p3_size, function()
	win3:resize( 7 );
end );

win3:set_callback( "OnShow", function()
	cur_playlist = win3;
	--win2:set_picture( p2_playlist, i2_playlist_active, false );
	w2_pl.state = 1;
	--win2:animate( p2_playlist, p2_playlist, i2_playlist_active, fade_alpha, 255, 0, 100 );
	--playlist_button = i2_playlist_active_down;
end );

win3:set_callback( "OnSizeEnd", w3_check_scrollable );

win3:set_callback( "OnClose", function()
	w2_pl.state = 0;
	--if (win4:is_visible() == false) then
		--win2:reset_picture( p2_playlist, false, i2_tmp );
		--win2:animate( p2_playlist, p2_playlist, i2_playlist_active, fade_alpha, 255, 0, 100 );
		--playlist_button = i2_playlist_down;
	--end
end );

--[[win3:setActivate(
	function() win3:set_picture( p3_active, i3_active, true ); end,
	function() win3:reset_picture( p3_active, true ); end
);
]]

win3:set_callback( "OnWheelDown", function()
	w3_playlist:scroll(10);
	w3_check_scrollable();
end );
win3:set_callback( "OnWheelUp", function()
	w3_playlist:scroll(-10);
	w3_check_scrollable();
end );

function switch34()
	if (sync_pl_window_width == true) then
		pos = win4:get_pos();
		pos.width = win3:get_pos().width;
		win4:set_pos(pos);
	end
	win3:switch_to(win4);
end

win3:add_part_callback( "LDbl", p3_bar, switch34 );
win3:setup_button( bm_win3, p3_close, i3_close, function() win3:close(); end, "close playlist" );
win3:setup_button( bm_win3, p3_switch, i3_switch, switch34, "switch to playlist-shade-mode" );

win3:add_part_callback( "LUp", p_all, function() button_status = nil; end );


--############### WINDOW 4 - PLAYLIST SMALL ###############

i4_l = image.new(bm_win4, rect.new_size(0, 0, 25, 14));
i4_tt = image.new(bm_win4, rect.new_size(0, 15, 25, 14));
i4_r_active = image.new(bm_win4, rect.new_size(27, 0, 50, 14));
i4_r = image.new(bm_win4, rect.new_size(27, 15, 50, 14));
i4_switch = image.new(bm_win4, rect.new_size(78, 0, 9, 9));
i4_close = image.new(bm_win4, rect.new_size(78, 10, 9, 9));

p4_l = rect.new_size(0, 0, 25, 14);
p4_tt = rect.new(25, 0, -50, 0);
p4_r = rect.new(-50, 0, 0, 0);
p4_text = rect.new(5, 2, -30, -4);
p4_bar = rect.new(0, 0, -30, 0);
p4_size = rect.new(-30, 3, -21, 12);
p4_switch = rect.new(-21, 3, -12, 12);
p4_close = rect.new(-12, 3, -3, 12 );

--[[i4_main = rect.new1(0, 0, 274, 13);
i4_close = rect.new1(304, 0, 312, 8);
i4_switch = rect.new1(313, 0, 321, 8);
i4_panel_active = rect.new1(275, 0, 303, 13);

p4_edge = rect.new1(10, 0, 240, 0);
p4_text = rect.new1(5,2, 245, 11);
p4_panel = rect.new1(246, 0, 274, 13);
p4_size = rect.new1(244, 3, 252, 11);
p4_switch = rect.new1(254, 3, 262, 11);
p4_close = rect.new1(264, 3, 272, 11);
p4_bar = rect.new1(0, 0, 245, 13);
]]
text4_title = textfield.new( p4_text, pl_small_text, 0, text_field_font, text_field_color );

win4 = window.new("pl - small", 275, 14, rect.new(0, 0, 275, 14), 1 );
win4:add_paint_part( p4_l, i4_l);
win4:add_paint_part( p4_tt, i4_tt );
win4:add_paint_part( p4_r, i4_r );
win4:add( text4_title );
--win4:add( p4_bar, p4_size, p4_switch, p4_close );
win4:add(p4_bar, p4_size);

win4:add_part_callback( "LDown", p4_size, function()
	win4:resize( 1 );
end );

--[[win4:setActivate(
	function() win4:set_picture( p4_panel, i4_panel_active, true ); end,
	function() win4:reset_picture( p4_panel, true ); end
);
]]

win4:set_callback( "OnShow", function()
	cur_playlist = win4;
	w2_pl.state = 1;
end );

win4:set_callback( "OnClose", function()
	w2_pl.state = 0;
end );

function switch43()
	if (sync_pl_window_width == true) then
		pos = win3:get_pos();
		pos.width = win4:get_pos().width;
		win3:set_pos(pos);
	end
	win4:switch_to(win3);
end

win4:add_part_callback( "LDbl", p4_bar, switch43 );
win4:setup_button( bm_win4, p4_switch, i4_switch, switch43, "switch to full playlist" );
win4:setup_button( bm_win4, p4_close, i4_close, function() win4:close(); end, "close playlist" );

win4:add_part_callback( "LUp", p_all, function() button_status = nil; end );

function playlist_newTrack()
	--if (win4:is_visible()) then
		text4_title:update();
	--end
end

--########################################################

vol_gfx = -1;
set_global_callback( "OnVolumeChange", function()
	if (win2:is_visible()) then
		local max = vol_bar.max;
		if (max < -foobar.get_volume()) then
			vol_bar.max = -foobar.get_volume();
			local max = -foobar.get_volume();
		end
		local pos = max + foobar.get_volume();
		--vol_bar:set( "pos", pos );
		local k = math.floor((pos * 27) / max);
		if (k < 0) then k = 0; end
		if (k ~= vol_gfx) then
			vol_gfx = k;
			k = k * 15;
			i2_vol_tmp.top = k;
			i2_vol_tmp.bottom = k + 13;
			bm_win2:copy_to(bm_win2, p2_vol2.left, p2_vol2.top, i2_vol_tmp.left, i2_vol_tmp.top, p2_vol2.width, p2_vol2.height);
			--win2:set_picture( p2_vol2, i2_vol_tmp, true, 0 );
			win2:redraw( p2_vol2 );
		end
		vol_bar.pos = pos;
		set_info( string.format("Volume: %.2f dB", foobar.get_volume() / 100) );
	end
end );

set_global_callback( "OnOrderChange", w2_update_order );

set_global_callback( "OnUnload", function()
	config.save(win1:is_visible() and (text_time1:get_text() == text_field_opt2) or
		(text_time2:get_text() == text_field_opt2), "show remaining time");
	local w;
	remove_tray_icon( 0 );
end );

set_global_callback( "OnStop", function()
	seek_bar.show = false;
	seek_bar.enabled = false;
	seek_bar:redraw();
	if (win1:is_visible()) then
		w1_newTrack();
	end
	if (win2:is_visible()) then
		w2_newTrack();
		--timer1:stop();
	end
end );

set_global_callback( "OnStart", function()
	seek_bar.show = true;
	seek_bar.enabled = true;
	seek_bar:redraw();
end );

set_global_callback( "OnDynamic", function()
	text4_title:update();
	w3_playlist:redraw();
end );

cur_playlist = win3;

docking.set_snap_gap( 10 );
docking.add_window(win1);
docking.add_window(win2);
docking.add_window(win3);
docking.add_window(win4);

if (config.load_windows() ~= true) then
	win2:create();
end

show_tray_std();